/*******   START OF CREDITS   *******
   mudlib:  Basis
   file:    /bin/daemon/shutdownd.c
   author:  Truilkan
   created: 1992/09/26
   $Locker:  $
   $Source: /usr/local/mud/libs/basis/bin/daemon/RCS/shutdownd.c,v $
   $Revision: 1.1 $
   $Author: garnett $
   $Date: 92/09/26 22:21:17 $
   $State: Exp $
   $Log:   shutdownd.c,v $
   Revision 1.1  92/09/26  22:21:17  garnett
   Initial revision
   Version 1.2:
   Date:	1993 January 4th
   By:		Pallando ( Douglas Reay )
   File:	TMI-2 /adm/daemons/shutdownd.c
   Comments:	Added in the delay option and Apocalypse bits.
   Version 1.3:
   Date:        1993 January 14th
   Comments:    Move emotes to seperate file (easier for other muds to change)
   Version 1.4:
   Date:        1993 April 2nd
   Comments:    Added stop_shutdown()
*******   END OF CREDITS   *******/

#include <config.h>
#include <uid.h>
#include <daemons.h>

#define log( x )
#define EMOTE_FILE "/adm/daemons/sh_ragnarok.t"

string *emotes;
int num_emot; // the number of emotes
int s_sec; //	The time() the shutdown is due at, in seconds.

int query_shutdown() { return s_sec; }
mixed query_emotes() { return emotes; }

void
save_daemons()
{
   EMOTE_D->save_data();
   CMWHO_D->halt();
   users()->save_data();
}

void
do_shutdown(int how)
{
   if( geteuid( previous_object() ) != ROOT_UID ) return;
   save_daemons();
   shutdown(how);
}

varargs
int start_shutdown( int how, int delay )
{
  if( geteuid( previous_object() ) != ROOT_UID ) return s_sec;
  if( delay < 0 ) return s_sec;
  if( this_player() )
    shout( this_player()-> query( "cap_name" ) + " cackles: The ends of the"+
      " world is nigh.  Prepare to meet thy DOOM!\n" );
  if( !delay )
  {
    do_shutdown( how );
    return time();
  }
  s_sec = time() + ( delay * 60 );
  call_out( "count_down", 1, how );
  return s_sec;
}

string get_emote( int delay )
{
  if( !emotes )
  {
    emotes = explode( read_file( EMOTE_FILE ), "###\n" );
    num_emot = sizeof( emotes ) - 1;
  }
  if( delay < num_emot ) return emotes[(num_emot-delay)];
  return delay + " minutes until " + emotes[0] + ".\n";
}

void count_down( int how )
{
  int delay;

  if( geteuid( previous_object() ) != ROOT_UID ) return;
  delay = ( s_sec - time() ) / 60;
  shout( get_emote( delay ) );
  shout( "The mud shuts down in " + delay + " minutes.\n" );
  if(this_player())  
    tell_object(this_player(),"Mud shutdown in " + delay + " minutes.\n");
  if( delay < 1 )
  {
    do_shutdown( how );
    return;
  }
  call_out( "count_down", 60, how );
}

int stop_shutdown()
{
  if( geteuid( previous_object() ) != ROOT_UID ) return 0;
  s_sec = 0;
  remove_call_out( "count_down" );
  if( this_player() )
    shout( this_player()-> query( "cap_name" ) + 
      " the Powerful intervenes to save the world.\n" );
// Blessed are the peacemakers, for they shall save your hard won kit.
  return 1;
}
