/*
// These are functions useful for determining the actual time a player is
// in, based on an environment variable, TZONE.
//
// 20.Jan.92
//
// Written by DocZ @ TMI.
//
*/

// This controls the MUD local time zone. Define your time zone as the
// number of hours to ADD to Greenwich Mean Time to get your time zone.
// For example: Greenwich Time = 0, British Standard = -1, Eastern Standard
// = -5,  Central Standard = -6, Central European = +1, Australian Standard
// = +12.

#define LOCAL_TIME_ZONE -5


int query_tzone(string str)
 {
  int offset; 
  switch (str)
   {
    case "EST": { offset = - 5 - LOCAL_TIME_ZONE; break; }
    case "CST": { offset = - 6 - LOCAL_TIME_ZONE; break; }
    case "MST": { offset = - 7 - LOCAL_TIME_ZONE; break; }
    case "PST": { offset = - 8 - LOCAL_TIME_ZONE; break; }
    case "BST": { offset = - 1 - LOCAL_TIME_ZONE; break; } /* OBO */
    case "GMT": { offset =   0 - LOCAL_TIME_ZONE; break; }
    case "CET": { offset =   1 - LOCAL_TIME_ZONE; break; }
    case "EET": { offset =   2 - LOCAL_TIME_ZONE; break; }
    case "AST" : { offset =  12 - LOCAL_TIME_ZONE; break ; }
    default   : { offset = 999; break; }
   }
   if (offset > 24) {return 0;} /* returns 0 if error */
   offset = offset * 60 * 60;
   return (time()+offset);
}

void show_tzone_list()
{
    write("\tEST is Eastern Standard Time.");
    write("\tCST is Central Standard Time.\n");
    write("\tMST is Mountain Standard Time.");
    write("\tPST is Pacific Standard Time.\n");
    write("\tGMT is Greenwhich Mean Time.");
    write("\tBST is British Summer Time.\n");
    write("\n\tIf _YOUR_ time zone isn't listed, leave mail to DOCZ.\n"
    +"\tBe sure to include the abreviation, the full name, and the\n"
    +"\tnumber of hours difference from GST (Greenwhich Standard)!\n");
    return;
}
