/*
**        File : /adm/daemons/ts.c
**     Creator : Tzar @ WizMud
**  Created on : 03-27-93
** First coded by: Huthar@portals
** Rewritten     : Blackthorn@Genocide (92-10-29)
** Rewritten     : Pallando@tmi-2 (92-12-12)
** Printed out, and completely recoded by Tzar @ WizMud
** Description :
**         This file is the Intermud Tell server.
**
** Ghost status notification added by Watcher@TMI (93-4-3)
*/

#include <channels.h>
#include <network.h>
#include <socket.h>
 
#define IT 60
/* If you change this, please change it also in /cmds/std/_tell.c */
#define NH " is not on this mud."
#define GS 1
#define LOG_FILE "/log/TS"
#define CHANNEL_FILE "/adm/etc/intermud_channels"
#define CHANNEL_INTERMUDS "/adm/etc/channel_intermuds"

inherit "/cmds/channels/std/broadcast";

string *muds;
string *cm;
mapping channels;
mapping reqs;

string tell_user(string who_from, string mud_from, string who_to, string msg);
void close_connection(mixed id);
mixed check_channel(string str);
int check_mud(string m);
void get_cms();
void get_channels();

void create()
{
      mapping ml;

	muds = ({});
	cm = ({});
	reqs = ([]);
	channels = ([]);

      seteuid( getuid() );
      ml = NAME_SERVER->query_muds();
      muds = keys(ml);
      muds -= ({ "DEFAULT" });
get_cms();
get_channels();
}

/*  This function recieves the messages from other muds  */

void read_callback(int id, string message)
{
	string org, mud, to, msg, tmp;
	mixed *ss;
	object ob, sender;
       int l;

       if (!message)
       {
               return close_connection(({ id }));
       }

       log_file(LOG_FILE, "read_callback : id = "+ id + " -- msg = "+ msg + "\n");
       if (sscanf(message, "%s@%s tells %s: %s", org, mud, to, msg) != 4)
       {
		return close_connection(({id}));
       }
       l = strlen(msg)-1;
       if(msg[l..l] == "\n")
       {
             msg = msg[0..(l-1)];
       }
       if (msg == "Cannot find Interwiz here." ||
           msg == "Cannot find Intermud here")
       {
              return close_connection(({id}));
       }
       to = lower_case(to);
       if (org == "TS" || org == "Game Driver")
       {
               ob = find_player(to);
               if (ob)
               {
                       tell_object(ob, "Message from "+capitalize(mud)+"'s Tell server:\n"+wrap( msg ));
               }
       }
       else
       {
		if ((ss = check_channel(to)))
		{
			broadcast_channel(ss[0], ss[1], msg, 
				capitalize(org)+"@"+capitalize(mud));
		}
               else
               {
                       INETD->write_socket(id, "TS@" + THIS_MUD + " tells "+
                              lower_case( org) + ": "+
                              tell_user(org, mud, to, msg) + "\n");
               }
       }
	close_connection(({id}));
}

/* This is called by the remote mud when a connection is requested */

void service_callback(int id)
{
      string name;

	if (!reqs[id])
      {
              return;
      }
      if (objectp(reqs[id][0]))
      {
		name = reqs[id][0]->query("cap_name");
      }
      else
      {
		if (stringp(reqs[id][0]))
             {
		    name = reqs[id][0];
             }
             else
             {
                   close_connection(id);
                   return;
             }
     }
     INETD->write_socket(id, name + "@" + THIS_MUD + " tells " +
		reqs[id][1] + ": " + reqs[id][3]+"\n");
     if (objectp(reqs[id][0]))
     {
		tell_object(reqs[id][0], "Remote tell was sent.\n");
     }
     call_out("close_connection", 12, id);
}

/* this function is called by service_callback() to close the conenction */

void close_connection(mixed id)
{
      if (intp(id))
      {
           map_delete(reqs, id);
      }
      else
      {
           id = id[0];
      }
      INETD->close_socket(id);
}

/* This is used by other uses on this mud to tell users on other muds */

string tell_user(string who_from, string mud_from, string who_to, string msg)
{
	object ob, sender;
	string tmp;
       string ret, rec;
       int ps, pr, is, ir;

       log_file(LOG_FILE, "tell_user: "+ who_from + (mud_from ? ("@"+mud_from) : "") +
              " tells " + who_to + ": " + msg);
if (who_to == "subscribe-to-channels")
 {
		if (THIS_MUD != "tmi-2")
		{
			return "Sorry, you can only Subscribe to the channels from TMI-2.\n"; }
		if (check_mud(mud_from))
		{
			return "You are already in the list.\n";
		}
		write_file(CHANNEL_INTERMUDS, mud_from+"\n");
		get_cms();
		return "You've been added.  Please get the newest version of the files from TMI-2.\n";
}
       if (!who_from || !who_to || !msg)
       {
             return "Syntax: tell <who> <msg>";
       }
       if (who_to == "") {
	     return "Who do you want to tell?";
       }
       rec = lower_case(who_to);
       who_from = lower_case(who_from);
       ob = find_player(rec);
       if (!ob)
       {
             ob = find_object(rec);
       }
       if (!ob)
       {
            ob = find_living(rec);
       }
       who_to = capitalize(who_to);

	if(!ob)  return who_to + " " + NH;
 
	pr = wizardp(ob);
       ir = ob->query("invisible");
       sender = find_player(who_from);
        if ( mud_from ) ps = 0;
	else if( member_group( who_from, "admin" ) ) ps = 2;
	else if( sender && wizardp(sender) ) ps = 1;

        if ( ir > ps )
	{
		return capitalize(who_to) + NH;
	}
       if (ob == 0)
       {
	  return who_to + NH;
       }
       if (!interactive(ob))
       {
		return who_to + " is presently net-dead.";
       }
      if(ob->query("busy") && ps != 2)
       {
	    return who_to + " is busy right now, try again later.";
       }
      if (is > pr)
	who_from = "Someone";
       tell_object(ob, wrap( capitalize(who_from) + ( mud_from ?( "@" +
	   capitalize(mud_from)) : "") + " tells you: "+msg) );
	if (!mud_from)
	{
		ob->set("reply", who_from);
	}
	else
	{
		ob->set("reply", who_from + "@" + mud_from);
	}
       ret = "You tell "+capitalize(who_to)+": "+msg;
       if (ob->query("inactive"))
	{
		ret = capitalize(who_to)+" is presently inactive.\n" + ret;
        }
 
       if (ob->query("ghost")) 
	 ret = capitalize(who_to) + " is a ghost and cannot answer.\n" + ret;
 
       if (query_idle(ob) > IT)
       {
	     ret = who_to + " has been idle for " + format_time( query_idle( ob ) ) +
                  ".\n" + ret;
       }
       return ret;
}

/* This is called by cmd_tell and cmd_reply() */

string remote_tell( object source, string user, string mud, string msg )
{
      int id;

      mud = lower_case( mud );
      id = INETD-> open_service( mud, "tell" );
      if (id < 0)
          return "The Remote mud, "+capitalize(mud)+" does not exist.\n";
if (source == this_object())
	{
		reqs[id] = ({"TS", user, mud, msg});
	}
	else
	{
		reqs[id] = ({source, user, mud, msg});
	}
       return "Connecting to "+ capitalize(mud) + "...\n";
}

inter_channel(string who, string channel, string msg)
{
   int i, s, id;
object ob;
   string *msgs;
   int ii;

  ob = find_player(who);
  tell_object(ob, "You may not get a response for a while, it is slow getting the messsage around.\n");
  s = sizeof( cm );
    ii = 1;
   for(i = 0;i < s;i++)
   {
      if (lower_case(cm[i]) == THIS_MUD) continue;
	msgs = ({who, channel, lower_case(cm[i]), msg});
	call_out("connect_channel", ii, msgs, i);

	ii += 4;
   }
}

connect_channel(string *msgs, int i)
{
       string who, channel, msg;
	int id;

        id = INETD->open_service(cm[i], "tell");
	if (id > 0)
       {
		reqs[id] = msgs;
       }
}

void
get_cms()
{
	string file, mud;
	int i;

	file = CHANNEL_INTERMUDS;

	for(i = 1;;i++)
	{
		mud = read_file(file, i);
		if (!mud) { return; }
		sscanf(mud, "%s\n", mud);
		cm += ({mud});
	}
}

write_cms()
{
	int i;

	for(i = 0;i < sizeof(cm);i++)
	{
		write(cm[i]+"\n");
	}
}

void
get_channels()
{
	string line, file, channel, msg;
	int chan;
	int i;
	string tmp1, tmp2;

	file = CHANNEL_FILE;

	for(i = 1;;i++)
	{
		line = read_file(file, i, 1);
		if (!line) { return; }
		if (line == "") { return; }
 if (sscanf(line, "%s:%s:%d\n", channel, msg, chan) != 3) { continue; }
		channels[channel] = ({ msg, chan });
	}
}

query_channels()
{
 string *c;
 int i;
  mixed *ss;


	c = keys(channels);
	for(i = 0;i < sizeof(c);i++)
	for(i = 0;i < sizeof(channels);i++)
	{
	ss = channels[c[i]];
	write("msg = "+ss[0]+"   ---   chan = "+ss[1]+"\n");
	}
}

mixed
check_channel(string str)
{
	if (channels[str]) { return channels[str]; }
}

int
check_mud(string m)
{
	int i;

	for(i = 0;i < sizeof(cm);i++)
	
	{
		if (cm[i] == m) { return 1; }
	}
	return 0;
}

