
//      File    :  /adm/daemons/userid.c
//      Creator :  Pinkfish@DiscWorld
//
//      Ported to TMI-2 1.0 mudlib by Watcher@TMI-2 (5/1/93)
//
//      This daemon will connect up to an authorization daemon and
//      and return a user's login name.

#include <priv.h>
#include <config.h>
#include <socket.h>
#include <daemons.h>

mapping found;

void create() {  found = ([ ]);  }

void query_userid() {
  string addr, bing;
  int port;

  seteuid(getuid(this_object()));
 
  addr = socket_address(previous_object());
 
  if (!addr) {
    call_other(previous_object(), "set", "userid", 0, MASTER_ONLY);
    return ;
  }
 
  sscanf(addr, "%s %d", bing, port);
  found[addr] = ({ previous_object(), addr, port });
  if (!found[bing])
    found[bing] = ({ addr });
  else
    found[bing] += ({ addr });
  INETD->open_to_service("auth", STREAM, addr);
}

/* Well.  We know what service we were opening... */
 
void failed(string reason, string machine, string service) {
  mixed junk;
  int i;

  if (found[machine])
    for (i=0;i<sizeof(found[machine]);i++) {
      junk = found[found[machine][i]];
      if (!junk) continue;
      if (junk[0])
        call_other(junk[0], junk[1]);
      map_delete(found, found[machine][i]);
    }
  map_delete(found, machine);
} /* failed() */

/* Ok...  zap the first one from this host down the tubes. */
void connected(int fd, string host) {
 
  if (!found[host]) {
    previous_object()->close_fd(fd);
    return ;
  }
 
  previous_object()->write_fd(fd, "4242 , "+
                             found[found[host][0]][3]+"\n\r");
  found[fd] = found[host][0];
  found[host] = found[host][1..1000];
  if (!sizeof(found[host]))
    map_delete(found, host);
} /* connected() */

void read_callback(int fd, string mess) {
  string name, machine_type, biggles;
  int port, mine;

  sscanf(mess, "%d , %d : %s : %s : %s", mine, port, biggles, machine_type,
               name);
  if (!found[fd]) {
    previous_object()->close_fd(fd);
    map_delete(found, fd);
    return ;
  }
  if (name)
    name = name[0..strlen(name)-3];
  call_other(found[found[fd]][0], "set", "userid", name, MASTER_ONLY);
  map_delete(found, found[fd]);
  map_delete(found, fd);
  previous_object()->close_fd(fd);
} /* read_callback() */
 
