// Intermud Mailer by Huthar@portals
// Touched up by Buddha@TMI for his own mudlib (name unknown).
// Zak 930127 20:05: Added
//	- 'Q' (quit no changes)
//	- 's' (save note, mark for delete)
//	- 'c' (save note, leave alone)
// Watcher 930327 added 'more' reading of the mail
// Zak 930411 fixed null subject bugs, added 'x' (same as 'q').

#include <mailer.h>
#include <config.h>
#include <daemons.h>
#include <uid.h>
#include <mudlib.h>

inherit SECURE_OBJECT ;


#define QUERY_NAME link_data("name")

static string owner;
static string *tto, *tcc;
static string tfrom, tsubject, tmessage;
static int tdate;
static int cmsg;
static int startup;
static int *delete;
static int start_flag;
static int in_mailer;
static int quitmailflag;

mixed to, cc;
string *from, *subject, *message;
int *date, *ref_cnt;
int *flags;

void do_groups(string args);
void do_reply(string cmd, string numstr);
void delete_mail(string arg);
void undelete_mail(string str);
string *expand_to(string *arr);
void read_mail(int num);
void do_header(string arg);
void mail(string cmd);
void get_to(string cmd);
void do_mail(string arg);
void headers(int start);
void do_help(string arg);
void get_cc(string arg);
void do_save(string cmd, string arg);

void create()
{
   seteuid(ROOT_UID);
   set("id", ({ "mailer" }) );
   // set("short", "portable mailer");
   delete = to = cc = flags = from = date = subject = ref_cnt = message = ({});
}

init()
{
   int i;
   int *exclude;

   if(in_mailer)
   {
      // write("A " + query("short") + " disappears as it leaves your grasp.\n");
      remove() ;
      return 1;
   }

   delete = to = cc = flags = from = date = subject = ref_cnt = message = ({});
   owner = (string)this_player()->QUERY_NAME;
   restore_object(MAILDIR + owner + "-mbox");

   if(!sizeof(to)) { cmsg = 0; return; }

   exclude = ({});
   for(i = 0,cmsg = -1; i < sizeof(to); i++)
   {
      if(flags[i] & OWNERDELETED)
	 exclude += ({ i });
   }
   for(i = sizeof(exclude) - 1; i >= 0; i--)
   {
      to = exclude_array(to,exclude[i]);
      cc = exclude_array(cc,exclude[i]);
      from = exclude_array(from,exclude[i]);
      subject = exclude_array(subject,exclude[i]);
      message = exclude_array(message,exclude[i]);
      date = exclude_array(date,exclude[i]);
      ref_cnt = exclude_array(ref_cnt,exclude[i]);
      flags = exclude_array(flags,exclude[i]);
   }
   for(i = 0,cmsg = -1; i < sizeof(date); i++)
   {
      if(!(flags[i] & MAIL_READ))
      {
	 cmsg = i;
	 break;
      }
   }
   delete = allocate(sizeof(to));
   if(cmsg == -1)
   {
      cmsg = sizeof(to) - 1;
      if((cmsg = sizeof(to) - 1) < 0)
	 cmsg = 0;
   }
}

int inccmsg()
{
   if(!sizeof(to))
   {
      cmsg = 0;
      return 0;
   }
   if(++cmsg >= sizeof(to))
      cmsg = sizeof(to) - 1;
   return cmsg;
}

int start_mail(string arg)
{
   start_flag = 0;
   init();
   write("Intermud Mailer v2.0  [? for help]\n");
   headers(0);
   do_mail(arg);
   return 1;
}

varargs do_mail(string cmd)
{
   in_mailer = 1;
   if(cmd && cmd!="")
   {
      quitmailflag = 1;
      mail(cmd) ;
      return 1;
   }
   write("& ");
   input_to("parse_mailcmd");
}

void do_quit(string cmd)
{
   int i,num;

   if (cmd != "Q")
   {
       for(i = 0; i < sizeof(to); i++)
       {
	  if(delete[i])
	  {
	     num++;
	     MAILER_D->remove_message(owner,subject[i],date[i]);
	  }
	  else
	     MAILER_D->set_flags(owner,subject[i],date[i],flags[i]);
       }
       if(!num)  write("No messages deleted.\n");
       else printf("%d message%s deleted.\n", num, (num == 1 ? "" : "s" ));
   }
   else
      write("No changes to mailbox.\n");
   MAILER_D->flush_files();
   in_mailer = 0;
   destruct(this_object());
   return;
}

void parse_mailcmd(string cmd)
{
   string arg;
   string verb;
   int num;
   string ocmd;

   ocmd = cmd;

   if(cmd == "")
   {
      if(start_flag && cmsg == inccmsg())
	 ocmd = "-1";
      else
	 ocmd = (cmsg+1)+"";  /* Ugly kludge! :) */
   }
   else
   {
      if(strlen(cmd) == 1)
	 arg = "";
      else
	 if(cmd[1] == ' ')
	 {
	    if(strlen(cmd) == 2)
	    {
	       arg = "";
	       cmd = cmd[0..0];
	    }
	    else
	    {
	       arg = cmd[2..strlen(cmd) - 1];
	       cmd = cmd[0 .. 0];
	    }
	 }
	 else
	 {
	    arg = cmd[1..strlen(cmd) - 1];
	    cmd = cmd[0 .. 0];
	 }
   }

   switch(cmd)
   {
      case "g":
	 do_groups(arg);
	 break;
      case "R":
      case "r":
	 do_reply(cmd,arg);
	 return;
      case "?":
	 do_help(arg);
	 break;
      case "Q":
      case "q":
      case "x":
	 do_quit(cmd);
	 return;
      case "m":
	 mail(arg);
	 return;
      case "u":
	 undelete_mail(arg);
	 break;
      case "d":
	 delete_mail(arg);
	 break;
      case "h":
	 do_header(arg);
	 break;
      case "c":
      case "s":
	 do_save(cmd, arg);
	 break;
      default:
	 if(ocmd && sscanf(ocmd,"%d", num) && num > 0 && num <= sizeof(to))
	 {
	    cmsg = num - 1;
	    start_flag = 1;
	    read_mail(num - 1);
	    return;
	 }
	 else
	    write("Invalid Command.\n");
   }
   do_mail();
}

int done_more() {
   do_mail();
return 1; }
 
void mail(string arg)
{
   if(!arg || arg=="")
   {
      write("To: ");
      input_to("get_to");
      return;
   }
   get_to(arg);
}

void get_to(string arg)
{
   string *tmp, *grparr, grp;
   int i;
   mixed grps;

   if(!arg || arg == "")
   {
      write("No users/groups specified.\n");
      do_mail();
      return;
   }

   tto = ({});
   tcc = ({});
   tfrom = (string)this_player()->QUERY_NAME;
   tdate = time();
/*  Commented out by Watcher (09/28/92) to tmp. patch erroring
   grparr = keys(grps = (mapping)GROUP_OB->query_groups()); // mudlib dependent
*/
   grparr = (string *)GROUP_OB->query_groups();
   tto = explode(arg," ");
   write("Subject: ");
   input_to("get_subject");
}

void get_subject(string sub)
{
   int i;
   if(!sub || sub == "")
   {
      write("Null subject line. Hope that's ok.\n");
      sub = "";
   }
   tsubject = sub;
   write("\n\nFrom: "+capitalize(tfrom)+"\n");
   write("To: ");
      for(i = 0; i < sizeof(tto); i++)
	 write(capitalize(tto[i])+" ");
   write("\n");
   write("Date: "+ctime(tdate)+"\n");
   write("Subject: "+tsubject+"\n");
   rm(TMP_DIR + "/"+tfrom+".tmail");
   this_player()->edit(TMP_DIR + "/"+tfrom+".tmail","get_text",this_object());
}

void abort()
{
   if(quitmailflag)
   {
      destruct(this_object());
      return;
   }
   do_mail();
}

void get_text()
{
   tmessage = read_file(TMP_DIR + "/"+tfrom+".tmail");
   rm(TMP_DIR + "/"+tfrom+".tmail");
   if(!this_player()->getenv("mail_no_cc"))
   {
      write("Cc: ");
      input_to("get_cc");
      return;
   }
   get_cc("");
}

void get_cc(string arg)
{
   int i;
   string *rtn;
   string tmpfile;

   if(arg && arg != "")
      tcc = uniq_array( tcc + explode(arg," ") );

   rtn = (string *)MAILER_D->send_mail(tto,tcc,tfrom,tsubject,tdate,tmessage);

   if(sizeof(rtn))
   {
      write("Mailing to: ");
      for(i = 0; i < sizeof(rtn); i++)
	 if(stringp(rtn[i]))
	    write(capitalize(rtn[i])+" ");
      write("\n");
   }
   else
   {
      tmpfile = TMP_DIR + "/"+owner+".dead-letter";
      write("No recipients found. Appending to: '"+tmpfile+"'\n");
      write_file(tmpfile,tmessage+"\n");
   }

   MAIL_SERVER->flush_mail_queue();

   if(quitmailflag)
   {
      MAILER_D->flush_files();
      destruct(this_object());
   }
   else
     do_mail();
}


void do_header(string arg)
{
   int start;

   if(!arg || arg == "")
      headers(0);
   else
   {
      sscanf(arg,"%d",start);
      if(start <= sizeof(to) && start > 0)
	 headers(start - 1);
      else
	 write("Mail # out of range.\n");
   }
}

void headers(int start)
{
   int i;

   if(!sizeof(to))
   {
      write("No mail.\n");
      cmsg = 0;
      return;
   }
   for(i = start; i < sizeof(to); i++)
   {
#if 0
      printf("%s %s %d %s [%s] \"%s\"\n",
	flags[i] & MAIL_READ ? " " : "U",
	i == cmsg ? (delete[i] ? "<" : ">" ) : (delete[i] ? "*" : " "),
        i+1,
	capitalize(from[i]),
	ctime(date[i]),
	subject[i]);
#endif
      write(flags[i] & MAIL_READ ? " " : "U");
      if(i == cmsg)
	 write(delete[i] ? "< " : "> ");
      else
	 write(delete[i] ? "* " : "  ");
      printf("%d %s [%s] \"%s\"\n",i+1,capitalize(from[i]),
	 ctime(date[i]),subject[i]);
   }
}

void read_mail(int num)
{
   mapping msg;
   string tmp_msg;
   int i;

   tmp_msg = "";
 
   if(!pointerp(to[num]))
      msg = (mapping)MAILER_D->get_message(to[num],subject[num],date[num]);
   else
      msg = ([ "to" : to[num], "cc" : cc[num], "from" : from[num], "date" : date[num],
	 "subject" : subject[num], "ref_cnt" : ref_cnt[num],
	 "flags" : flags[num], "message" : message[num] ]);

   if(!sizeof(msg))
   {
      write("That message is no longer valid.\n");
      return;
   }

   tmp_msg += "Message #" + (num + 1);
   tmp_msg += (delete[num] ? " \t[DELETED]\n" : "\n");
   tmp_msg += "To     : ";
   for(i = 0; i < sizeof(msg["to"]); i++)
      tmp_msg += capitalize(msg["to"][i]) + " ";
   tmp_msg += "\n";
   if(sizeof(msg["cc"]))
   {
      tmp_msg += "Cc     : ";
      for(i = 0; i < sizeof(msg["cc"]); i++)
	 tmp_msg += capitalize(msg["cc"][i]) + " ";
      tmp_msg += "\n";
   }
   tmp_msg += "From   : " + capitalize(msg["from"]) + "\n";
   tmp_msg += "Date   : " + ctime(msg["date"]) + "\n";
   tmp_msg += "Subject: " + msg["subject"] + "\n";
   tmp_msg += "-------------------------------------------------------------------------------\n";
   tmp_msg += msg["message"] + "\n";
 
   this_player()->more( explode(tmp_msg, "\n") );
 
   flags[num] |= MAIL_READ;
}

void delete_mail(string str)
{
   int num;

   if(!str || str == "")
      num = cmsg + 1;
   else
      sscanf(str,"%d",num);

   if(num < 1 || num > sizeof(date))
   {
      write("Illegal message value.\n");
      do_mail();
      return;
   }

   num -= 1;

   if(delete[num])
   {
      write("Message #"+(num + 1)+" already deleted.\n");
      return;
   }

   delete[num] = 1;
   write("Message #"+(num + 1)+" marked for deletion.\n");
}

void do_help(string arg)
{
   cat(MAILER_SHORT);
}

void undelete_mail(string str)
{
   int num;

   if(!str || str == "")
      num = cmsg + 1;
   else
      sscanf(str,"%d",num);

   if(num < 1 || num > sizeof(date))
   {
      write("Illegal message value.\n");
      return;
   }

   num -= 1;

   if(!delete[num])
   {
      write("Message #"+(num + 1)+" is noty deleted.\n");
      return;
   }

   delete[num] = 0;
   write("Message #"+(num + 1)+" is restored.\n");
}

void do_reply(string cmd, string numstr)
{
   string *tmp;
   mapping msg;
   int num;
   int i;

   if(!numstr || numstr == "")
      num = cmsg + 1;
   else
      sscanf(numstr,"%d",num);

   if(num < 1 || num > sizeof(to))
   {
      write("Illegal message number!\n");
      return;
   }

   if(!pointerp(to[--num]))
      msg = (mapping)MAILER_D->get_message(to[num],subject[num],date[num]);
   else
      msg = ([ "to" : to[num], "cc" : cc[num], "from" : from[num], "date" : date[num],
	 "subject" : subject[num], "ref_cnt" : ref_cnt[num],
	 "flags" : flags[num], "message" : message[num] ]);

   if(!sizeof(msg))
   {
      write("That message is no longer valid.\n");
      return;
   }

   if(cmd == "r")
   {
      tto = ({ msg["from"] });
      tcc = ({});
   }
   else
   {
      tto = uniq_array( ({ msg["from"] }) + msg["to"] );
      tcc = msg[cc];
   }

   tfrom = (string)this_player()->QUERY_NAME;
   tdate = time();

   tsubject = msg["subject"];
   if(strlen(tsubject) < 4 || tsubject [0 .. 3] != "RE: ")
      tsubject = "RE: "+tsubject;

   write("\n\nFrom    : "+capitalize(tfrom)+"\n");
   write("To     : ");
      for(i = 0; i < sizeof(tto); i++)
	 write(capitalize(tto[i])+" ");
   write("\n");
   if(sizeof(msg["cc"]))
   {
      write("Cc     : ");
      for(i = 0; i < sizeof(msg["cc"]); i++)
	 write(capitalize(msg["cc"][i])+" ");
      write("\n");
   }
   write("Date   : "+ctime(tdate)+"\n");
   write("Subject: "+tsubject+"\n");
   rm(TMP_DIR + "/"+tfrom+".tmail");
   if(this_player()->getenv("mail_use_reply_text"))
   {
      tmp = explode(msg["message"],"\n");
      tmessage = capitalize(msg["from"])+ " writes:\n> "+
	 implode(tmp,"\n> ");
      write_file(TMP_DIR + "/"+tfrom+".tmail",tmessage+"\n");
   }
   this_player()->edit(TMP_DIR + "/"+tfrom+".tmail","get_text",this_object());
}

void do_groups(string arg)
{
   mapping grps;
   string *groups;
   int i;

   grps = (mapping)GROUP_OB->query_groups();
   if(arg && arg != "")
   {
      if(!sizeof(grps[arg]))
      {
	 write("That group does not exist!\n");
	 return;
      }
      write("Members for group ("+arg+"):\n");
      for(i = 0; i < sizeof(grps[arg]); i++)
	 write("   "+grps[arg][i]+"\n");
      return;
   }
   groups = keys(grps);
   write("\nCurrent active groups:\n");
   for(i = 0; i < sizeof(groups); i++)
      write("   "+groups[i]+"\n");
   write("\n");
}

void do_save(string cmd, string arg)
{
    string file, tmp;
    mapping msg;
    int i, num;

    if (!wizardp(this_player()))
    {
	write("Sorry - for the time being only wizards can save mail.\n");
	return;
    }
    num = 0;
    if (!arg || arg == "" || (sscanf(arg, "%s %d", file, num) != 2 &&
		 sscanf(arg, "%s", file) != 1) )
    {
	printf("Usage: %s <file> [<num>]\n", cmd);
	return;
    }
    if (sscanf(arg, "%s %d", file, num) != 2)
	num = cmsg + 1;
    if(num < 1 || num > sizeof(to))
    {
	write("Illegal message number!\n");
	return;
    }
    file = resolv_path("cwd", file);
    if (!master()->valid_write(file,(string)this_player()->query("name"), "do_save"))
    {
	write(file + ": Permission denied.\n");
	return;
    }
    write("file: " + dump_variable(file) + "\n");

    if(!pointerp(to[--num]))
	msg = (mapping)MAILER_D->get_message(to[num],subject[num],date[num]);
    else
	msg = ([ "to" : to[num], "cc" : cc[num], "from" : from[num],
		"date" : date[num], "subject" : subject[num],
		"ref_cnt" : ref_cnt[num], "flags" : flags[num],
		"message" : message[num] ]);
    if(!sizeof(msg))
    {
	write("That message is no longer valid.\n");
	return;
    }

    write_file(file, "From   : "+capitalize(msg["from"])+"\n");
    write_file(file, "To     : ");
    tmp = "";
    for(i = 0; i < sizeof(msg["to"]); i++)
	tmp += capitalize(msg["to"][i])+" ";
    write_file(file, tmp + "\n");
    if(sizeof(msg["cc"]))
    {
	write_file(file, "Cc     : ");
	tmp = "";
	for(i = 0; i < sizeof(msg["cc"]); i++)
	    tmp += capitalize(msg["cc"][i])+" ";
	write_file(file, tmp + "\n");
    }
    write_file(file, "Date   : "+ctime(msg["date"])+"\n");
    write_file(file, "Subject: "+msg["subject"]+"\n");
    write_file(file, "------------------------------------------------------------------------------\n");
    write_file(file, msg["message"]+"\n");
    write("Message '" + msg["subject"] + "' written to: " + file + ".\n");
    if ( cmd == "s" )
    {
	delete[num] = 1;
    }
}

int valid_shadow() { return 1; }
