/*
// File: simul_efun.c
// This file holds a list of simulated efuns, that is loaded when
// the game is booted.  
// Written by Buddha@TMI (2-19-92)
// This file is part of the TMI distribution mudlib.
// Please be considerate and retain the header file if you use it.
*/

// Note: most simul_efuns ought to #include what they need, so that they
// can be loaded as independent modules for testing.  In order to prevent
// redefinition errors, it's wise to define a symbol (ex.: __CONFIG_H) in
// the include file, and check if it's defined before defining anything
// new.  See config.h for an example.

#include <uid.h>
#include <config.h>
#include <writef.h>

#include "/adm/simul_efun/copy.c"
#include "/adm/simul_efun/update_file.c"
#include "/adm/simul_efun/article.c"
#include "/adm/simul_efun/system.c"
#include "/adm/simul_efun/getoid.c"
#include "/adm/simul_efun/temp_file.c"
#include "/adm/simul_efun/base_name.c"
#include "/adm/simul_efun/dump_variable.c"
#include "/adm/simul_efun/mkdirs.c"
#include "/adm/simul_efun/data.c"
#include "/adm/simul_efun/existence.c"
#include "/adm/simul_efun/pronouns.c"
#include "/adm/simul_efun/creator_file.c"
#include "/adm/simul_efun/member_group.c"
#include "/adm/simul_efun/overrides.c"
#include "/adm/simul_efun/user_path.c"
#include "/adm/simul_efun/resolv_path.c"
#include "/adm/simul_efun/tilde_path.c"  
#include "/adm/simul_efun/atoi.c"
#include "/adm/simul_efun/write.c"
#include "/adm/simul_efun/say.c"
#include "/adm/simul_efun/shout.c"
#include "/adm/simul_efun/get_char.c"
#include "/adm/simul_efun/get_object.c"
#include "/adm/simul_efun/format_time.c"
#include "/adm/simul_efun/exclude_array.c"
#include "/adm/simul_efun/unique_mapping.c"
#include "/adm/simul_efun/find_object_or_load.c"
#include "/adm/simul_efun/format_string.c"
#include "/adm/simul_efun/idle.c"
#include "/adm/simul_efun/path_file.c"
#include "/adm/simul_efun/index.c"
#include "/adm/simul_efun/merge.c"
#include "/adm/simul_efun/pluralize.c"
#include "/adm/simul_efun/emote.c"
#include "/adm/simul_efun/substr.c"
#include "/adm/simul_efun/slice_array.c"
#include "/adm/simul_efun/tell_group.c"
#include "/adm/simul_efun/tell_object.c"
#include "/adm/simul_efun/tell_room.c"
#include "/adm/simul_efun/uniq_array.c"
#include "/adm/simul_efun/vt100.c"
#include "/adm/simul_efun/wrap.c"
#include "/adm/simul_efun/writef.c"
#include "/adm/simul_efun/identify.c"
#include "/adm/simul_efun/hiddenp.c"
#include "/adm/simul_efun/visible.c"
#include "/adm/simul_efun/match_string.c"
