// The command to banish a site.
// Just an interface to a daemon.
// Command from Buddha, daemon from Dainia@Dreamshadow

#include <mudlib.h>
#include <daemons.h>

inherit DAEMON;


int cmd_banish(string site) {

	if (!member_group(geteuid(previous_object()), "admin")) {
		notify_fail("You are not permitted to banish sites.\n");
		return 0;
	}
	BANISH_D->restrict_site(site);
	write("People from " + site +
		" can no longer create new characters.\n");
	return  1;
}

void help() {
	write("usage: banish <site>\n"
"The <site> string may be either an IP number of the form 123.123.123.123 or\n"
"it may contain wildcards, such as 123.123.*.*, which will banish all\n"
"machines with IP numbers starting with 123.123.  When a user connects from\n"
"a banished address, the check is made if a new character is created or if\n"
"the guest character is used.\n"
"\nSee also: nuke\n");
}

