// channels.c
// Received from DreamShadow, written by Anne (3/8/92)
// Implemented on TMI by Sulam (april 12, 92)

#include <mudlib.h>
#include <config.h>
#include <channels.h>

inherit DAEMON;
inherit "/cmds/channels/std/broadcast";

int help();

#define SPACES \
"                                                                            "
string pad(string arg, int len)
	{	if (strlen(arg) >= len)
			return arg;

		return arg + extract(SPACES, 0, len - strlen(arg) - 1);
	}

/* return 1 if get the message off, else 0 */
int do_channel(string verb, string verbsing, int bit, string message)
   {  object *list;
      string Me; /* Not necessary, just for efficiency rather than 
                  * calling the method over and over */

      int Counter;
      int DisplayCount;

      if ((int) this_player()->test_flag(NO_CHANNEL))
         {  write("Your channel privileges are revoked.\n");
            return 0;
         }

      if (!message)
         {  if ((int) this_player()->test_flag(bit))
               {  write("You tune out the " + verbsing + " channel.\n");
                  this_player()->clear_flag(bit);
               }
            else
               {  write("You tune in the " + verbsing + " channel.\n");
                  this_player()->set_flag(bit);
               }
            return 0;
         }

      if (message == "list")
         {  list = users();
            write("The following people have the " 
               + verbsing + " channel tuned in:\n");
            DisplayCount = 0;
            for (Counter = 0; Counter < sizeof(list); Counter++)
               if ((int) list[Counter]->test_flag(bit)
                   && ! ((int) list[Counter]->test_flag(QUIET_PLAY)))
                  write(pad((string) list[Counter]->query("name"), 12)
                        + ((DisplayCount++) % 6 == 5 ? "\n" : ""));
            write("<End>\n");
            return 0;
         }

      if (! ((int) this_player()->test_flag(bit)))
         {  write("You cannot " + verbsing 
                  + " unless you are tuned in to the channel.\n");
            return 0;
         }

      Me = capitalize((string) this_player()->query("name"));

      broadcast_channel( verb, bit, message, Me, this_player() );
      printf("%-=75s", "You " + verbsing + ": " + message + "\n");

      if (this_player()->test_flag(QUIET_PLAY))
         write("Remember, you are in quiet mode.\n");
      return 1;
   }

int help()
   {  write("The channels allow you to communicate with other players who\n"
         + "are tuned in to the same channel as you.  Each channel has a\n"
         + "specific purpose:\n\n"
         + "   gossip  --- General chatting\n"
         + " question  --- Ask a mud related question (admins monitor this)\n"
         + "   answer  --- Answer a question (same channel as question)\n");
      if (wizardp(this_player()))
	 {  write("      wiz  --- All purpose wizard channel\n") ;
	    write("\nAlso, each guild has its own channel.\n") ;
         }
      write("\nTo tune a channel in or out, just type its name alone,\n"
         + "without any message.  To send a message on a channel, type its\n"
         + "name followed by the message.\n\n"
         + "To see what channels are available to you, and whether you are\n"
         + "tuned in or not, use the 'channels' command.\n\n"
         + "To see who is tuned in to a channel, type the channel name with\n"
         + "list as the message; for example, to see who is on gossip, you\n"
         + "would type 'gossip list'.\n");

      return 1;
   }
// THIS WHOLE HELP NEEDS TO BE RE-WRITTEN 
// preferably to refer to the channels command for what channels there are

void sys_msg(string message)
   {  object *list;
      int Counter;
      

      list = users();
      for (Counter = 0; Counter < sizeof(list); Counter++)
	{ if (! ((int) list[Counter]->test_flag(QUIET_PLAY)))
               tell_object(list[Counter], "(SYS:  " + message + ")\n");
         }
   }
