// The "ed" command.
// Written by Buddha@TMI (2-19-92)
// Expanded by Buddha@TMI (6-10-92) for file locking.
// This file allows entry into the "ed" editor, and keeps track of
// people editing and what file they are editing, so that there are
// no stupid accidents involving two people editing the same file and
// losing changes.
// This is part of the TMI mudlib.  To strip away this header is very wrong.
// Very very wrong.

#include <mudlib.h>
#include <logs.h>

inherit DAEMON ;

// I have decided to use 2 arrays rather than a mapping for the 
// ease in searching for either the file or the editor.
// the only problem lies in keeping the lists accurate.


string *files, *editors;

void create() {
   files = editors = ({});
}

int cmd_ed(string file) {
   mixed *dir;
   int position;
   string tmp;
   
   if (in_edit(this_player())) {  // get real! you can't do this!
      notify_fail("You are already editing a file.\n");
      return 0;
   }
   
   // if the arrays are off, then reset them and pray nothing goes wrong.
      if (sizeof(editors) != sizeof(files)) create(); 
   
   // set our permissions.
   seteuid(geteuid(this_player()));
   
   // If they haven't given an arguement as to what file...
   if (!file) file=(string)this_player()->query("cwf");
   if (!file) { 
      write("Editing: [no file specified]\n");
      ed();
      return 1;
   }
   
   // get the filename to edit
   tmp = (string)this_player()->query("cwd");
   file = resolv_path(tmp, file);
   
   // Check if there is such a directory ..

   dir = explode(file, "/");
   if(file_size(implode( dir[0..sizeof(dir)-2], "/")) != -2) {
   write("Ed: No such directory file path.\n");
   return 1; }
 
   //  Check to make sure the file isn't actually a directory.
 
   if(directory_exists(file)) {
   notify_fail("Ed: Directory with that name already exists.\n");
   return 0; }
 
   // now check and see if the file is being edited by someone else.
 
      position = member_array(file, files);
 
   if (position != -1) { 
      // in this case, it is, so we make a temp copy.
      if (file_size(user_path(geteuid(this_player()))) != -2) {
         tmp = "/tmp/" + geteuid(this_player()) + "." + 
         implode(explode(file, "/"), "_");
       } else {
         tmp = user_path(geteuid(this_player())) + "tmp:" + 
         implode(explode(file, "/"), "_");
       }
      write("That file is being edited by " + editors[position] + ".\n");
      // cp(file, tmp);  // Is cp broken?
      if (file_size(tmp)) rm(tmp);
      write_file(tmp, read_file(file));
      file = tmp;
   }
   
   // Now, we add our name to the list, and the file to the list
   files += ({ file });
   editors += ({ capitalize(geteuid(this_player())) });
   this_player()->set("cwf",file);
   
   // Now let's make the message you see as you go into ed.
   tmp = "Editing: " + file;
   
   // Can we write here?
   if(!write_file(file, "")) tmp += " [read only]";
   
   // is it new?
   else if (!file_size(file)) tmp += " [new file]";
   tmp += "\n";
   
   // write the message that we're editing a file...
   write(tmp);
   
   // Yes, the evil admin logging... it can be circumvented, but
   // this tells us at least most of what gets changed.
   // actually, this would be better if it only logged when a crucial
   // file is actually changed.
 
#ifdef ED_LOG
   log_file(ED_LOG, wrap(capitalize(geteuid(this_player())) + " : \"" +
	file + "\" [" + extract(ctime(time()), 4, 15) + "]"));
#endif
 
   // okay, let's invoke the editor, and have it go to the done function after.
   if(!ed(file, "done_editing")) write("Failed to edit " + file + "\n");
   
   return 1;
}

void done_editing() {
   int ref;
 
   if (!editors) return;
 
   if(!geteuid(this_player()))  return;
   ref = member_array(capitalize(geteuid(this_player())), editors);
   if (ref == -1) { 
      log_file("ed_accidents", geteuid(this_player()) + " not listed\n");
      return;
   }
   if (file_size(files[ref]) == 0) rm(files[ref]);
   editors -= ({ editors[ref] });
   files -= ({ files[ref] });
   return;
}

void query_editors() {
   write(implode(editors, " ") + "\n");
   write(implode(files, " ") + "\n");
}
