// _findfunc.c
// A front-end for the function_exists efun.
// Mobydick, 12-11-92. Break from fixing bugs... :)
// Pallando, 93-02-13. Got annoyed when it wouldn't work on /std/user/more.c
//    so I changed it to use get_object() and check for shadows.

#include <mudlib.h>

inherit DAEMON;

int help() ;

int cmd_findfunc(string str) {

	string obname,func ;
	object ob, shad ;
	string res ;

	if (!str) return help() ;
	if (sscanf(str,"%s %s",func,obname)!=2) {
		return help() ;
	}
	ob = get_object( obname );
	if (!ob) {
		notify_fail ("Couldn't find that object.\n") ;
		return 0 ;
	}
        if( !( res = function_exists( func, ob ) ) )
	{
	  for( shad = shadow( ob, 0 ) ; shad ; shad = shadow( shad, 0 ) )
	    if( res = function_exists( func, shad ) ) { ob = shad; break; }
	  if( ob != shad )
	  {
	    notify_fail( "There is no function named \"" + func +
	      "\" in that object or its shadows.\n" );
	    return 0 ;
	  }
	}
	write ("That function is defined in "+res+".\n") ;
	return 1 ;
}

int help() {
	write ("Usage: findfunc <function> <object>\n\n"+
"The findfunc command will tell you what file defines the given function\n"+
"in the given object. It uses the function_exists efun: see the man page\n"+
"on the efun for more details.\n") ;
	return 1 ;
}
