/*
 * alias user command
 * this is from portals
 * One of them wrote it, again.
 * In the course of time it grew into part of the TMI-2 mudlib, via the
 * old TMI mudlib. In any event, you should leave this header on. Moby
 * added it in 4-9-93.
 */

#include <alias.h>
#include <mudlib.h>

inherit DAEMON ;

void print_aliases(mapping n, mapping x)
{
   int i;
   string *tmp;

   tmp = keys(n);
   write("Normal Aliases:\n");
   if(!sizeof(tmp))
      write("   No aliases defined.\n");
   else
      for(i = 0; i < sizeof(tmp); i++)
         printf("   %-15s %s\n",tmp[i],n[tmp[i]]);
   tmp = keys(x);
   write("Xverb Aliases:\n");
   if(!sizeof(tmp))
      write("   No aliases defined.\n");
   else
      for(i = 0; i < sizeof(tmp); i++)
         printf("   %-15s %s\n",tmp[i],x[tmp[i]]);
}

int cmd_alias(string str) {
  int i, sl;
  int index;
  string verb,cmd,*elements;
  mapping alias;
  object act_ob;
  
  act_ob = previous_object();
  
  if(str == "-global")
  {
    print_aliases((mapping)GA_SERVER->query_global_aliases(),
      (mapping)GA_SERVER->query_global_xaliases());
    return 1;
  }
  if(str == "-clear")
    {
      act_ob->clear_aliases();
      return 1;
    }
  alias = (mapping) act_ob->query_aliases();
  if (!alias) alias = ([]);
  if(!str)
    {
      elements = keys (alias);
      if(!elements || !sizeof(elements))
	{
	  write("No aliases defined.\n");
	  return 1;
	}
      print_aliases((mapping)act_ob->query_nalias(),
         (mapping)act_ob->query_xalias());
      return 1;
    }
  
 
  //  Strip out the leading spaces in the command request

  while(str[0] == ' ')   str = str[1..strlen(str)-1];
 
  if(sscanf(str,"%s %s",verb,cmd) == 2)
    {
      if (!verb || verb == "" || verb == " ") {
	  notify_fail("Sorry, you must specify a verb.\n");
      return 0; }
 
      if(verb=="alias")
	{
	  notify_fail ("Sorry, you can't alias 'alias'.\n");
	  return 0;
	}
      if (environment(this_player())) // it's probably not a new player
	if (!alias[verb])
	  write("Alias: "+verb+" ("+cmd+") added.\n");
	else
	  write("Alias: "+verb+" ("+cmd+") altered.\n");
      act_ob->add_alias(verb,cmd);
      return 1;
    }
  if(!alias[str])
    {
      write("The alias "+str+" wasn't found.\n");
      return 1;
    }
  printf("%-15s%s\n",str,alias[str]);
  return 1;
}



void help()
{
  write("Flags accepted:\n");
  write("    -clear\tClears all aliases.\n");
  
  write("\nalias\t\t\tView current aliases.\n");
  write("alias <alias> <command>\tSet the verb alias to execute command.\n");
  write("alias <alias>\t\tCheck the value of <alias>\n");
  write("unalias <alias>\t\tRemove <alias> from the alias list.\n");
  
  write("\nSubstitution variable that exist are:\n");
  write("    $# - Where # is the number of the word after the verb to substitute.\n");
  write("    $* - Will be substituted with everything after the verb.\n");
  write("\nPrefixing the alias' verb with a $ allows you to set up a verb that does not\n");
  write("require a space after it. i.e. 'alias $' say $*' will allow you to do says as:\n");
  write("'Hey! This is most Stufly!\n");
  write("\nLook at the default aliases for examples.\n");
}

