// _finger.c
// Written by Huthar. (NOT! By Wayfarer actually!)
// Funny guys, aren't they? Apparently Wayfarer is the real author.
// Robocoder and Mobydick tweaked it on 3-24-93 so that commands of the
// form "finger mobydick robocoder" would finger each user.

#include <config.h>
#include <socket.h>
#include <daemons.h>
#include <uid.h>
#include <inetd.h>
#include <mudlib.h>

inherit DAEMON;

// #define FINGER_SERVER "/bin/daemon/fs"

#define TIMEOUT 15

mapping requests;

void remote_finger(object me, string target, string mud);

int cmd_finger(string str)
{
  object ob;
   string tmp1,tmp2,tmp3,tmp4;
  
  if(!str)
    {
    write(FINGER_D->finger_all());
    return 1;
    }
  
  while (sscanf(str, "%s %s", tmp1, tmp2))
    {
    if(sscanf(tmp1,"%s@%s",tmp3,tmp4))
      {
        if (!tmp3) tmp3 = "" ;
        remote_finger(this_player(), tmp3, tmp4);
      } else if(tmp1 && tmp1 != "") {
        write((string)FINGER_D->finger_user(lower_case(tmp1)));
      }
      str = tmp2;
  }
  if (sscanf(str,"%s@%s",tmp3,tmp4))
    {
    if (!tmp3) tmp3 = "" ;
    remote_finger(this_player(), tmp3, tmp4);
  } else {
    write((string)FINGER_D->finger_user(lower_case(str)));
  }
  return 1;
}

void help ()
{
  write(
"The finger command is used by typing 'finger <player>'. It prints out\n"
+"information about the player, including name, position, location, and email\n"
+"address. It also lists info about thier current session.\n");
}

/*
 * Intermud finger command
 * Blackthorn@Genocide (10/31/92)
 */
 
void
create()
{
  requests = ([ ]);
  seteuid(getuid());
}
 
void
remote_finger(object source, string user,string mud)
{
  int id;
  id = INETD->open_service(mud, "finger", ({ user }));
  if (id < 0)
  {
    tell_object(source, "Remote mud does not exist.\n");
    return;
  }
  requests[id] = ({ source, user, mud });
  call_out("timeout", TIMEOUT, id);
}
 
void
read_callback(int id, string msg)
{
  if (!msg) return;
  tell_object(requests[id][0], msg);
}
 
void
close_callback(int id)
{
  map_delete(requests, id);
}   
 
void
timeout(int id)
{
  if (!requests[id]) return;
  tell_object(requests[id][0], "Remote finger connection timed out.\n");
  INETD->close_socket(id);
  map_delete(requests, id);
}
