
//	File	:  /cmds/std/_history.c
//	Creator	:  Probably Wayfarer
//
//	This command displays the list of the user's past commands
//	stored in the history stack.

#include <mudlib.h>
inherit DAEMON;

#define log( x ) log_file( "hist_err",wrap( x ) )

int cmd_history(string str) {
   int i,tptr;
   int max,cmd_num,ptr;
   string *history_queue;
   object act_ob;

   act_ob = previous_object();

   if ((int)act_ob->query_npc()) return 0 ; 
   max = (int)act_ob->query_max();
   cmd_num = (int)act_ob->query_cmd_num();
   ptr = (int)act_ob->query_ptr();
   history_queue = (string *)act_ob->query_history();

   if(!history_queue || !pointerp(history_queue)) {
   write("History seems to be broken. Please inform an Admin.\n");
   return 1; }

   tptr = ptr;

   for(i = max - 1; i >= 0; i--)
   {
      if(history_queue[tptr])
         printf("%4d %s\n",cmd_num - i,history_queue[tptr++]);
      else
         tptr++;
      if(tptr == max)
         tptr = 0;
   }
   return 1;
}

void help()
{
   write( @ENDHISTORY
History
-------
Command line history very similar to such un*x shells as csh.
There are 2 types of history access and these are listed below:

  !<command number>  : This will do the command <command number>.
  !!<string pattern> : This will match the most recent command which starts
                       with <string pattern>

EXAMPLES:
(Sample history list. Typing 'history' will show you your list!)
   7 grovel
   8 kill orc
   9 knock on east door
  10 bounce
  11 history
 
!!   - will cause you to 'history'
!7   - will cause you to 'grovel'
!-2  - will cause you to 'bounce'
!k   - will cause you to 'knock on east door'
!ki  - will cause you to 'kill orc'
ENDHISTORY
);
}
