 
//	File	:  /cmds/std/_mudlist.c
//	Creator	:  Watcher@TMI-2   (01/17/93)
//
//	Simple directory of all muds available in name server
 
#include <config.h>
#include <daemons.h>
#include <mudlib.h>
 
inherit DAEMON ;
 
#define	SYNTAX	"Syntax: mudlist [optional mudname]\n"
 
int cmd_mudlist(string str) {
   mapping mud_list;
   mixed *muds;
   string output;
   int loop;
 
   //	Obtain mapping containing mud data
 
   mud_list = NAME_SERVER->query_muds();
 
   if(!mud_list) {
   write("Mudlist:  No muds are presently stored in the mud name server.\n");
   return 1; }
 
   //	Get list of all mud names within name server
 
   muds = keys( mud_list );
   muds -= ({ "DEFAULT" });
 
   //	Place mudlist into alphabetical format
 
   muds = sort_array( muds, "compare", this_object() );
 
   // 	If mudname provided, search server's database for a match
   //	and display its cooresponding address
 
   if(str && str != "") {
 
   str = lower_case(str);
 
   if(!mapp( mud_list[str] )) {
   write("Requested mud is not listed in " + capitalize(mud_name()) +
	 "'s name server.\n");
   return 1; }
 
   write(capitalize(str) + "\t\t" + mud_list[str]["address"] + " " +
	 mud_list[str]["port"] + "\n");
   return 1; }
 
   output = "Mud name\t\tAddress\t\tPort\n========\t\t=======\t\t====\n";
 
   //	Loop through mud list and store one by one
 
   for(loop=0; loop<sizeof(muds); loop++) {
 
   if(strlen( muds[loop] ) < 8)  output += capitalize( muds[loop] ) + "\t\t\t";
   else output += capitalize( muds[loop] ) + "\t\t";
 
   output += mud_list[muds[loop]]["address"] + "\t" +
	     mud_list[muds[loop]]["port"] + "\n";
   }
 
   //	Display dumped mudlist output through user's more pager
 
   this_player()->more( explode(output, "\n") );
 
return 1; }
 
//	Comparison function for alphabetical sorting
 
int compare(string one, string two) {  return strcmp(one, two);  }
 
int help() {
 
   write( SYNTAX + "\n" +
     "This command gives a full list of all muds and their addresses\n" +
     "contained within " + capitalize(mud_name()) + "'s name server.  " +
     "If a mudname is given,\na match will be attempted against the server " +
     "and its address displayed.\n");
 
return 1; }
 
