// This is part of the TMI distribution mudlib.
// Please retain this header if you use this file.
// Written by Sulam (12-9-91)
// Help added by Brian (1/28/92)
// A security loop-hole found by Ellery and fixed by Pallando. (93/01/14)
// "Multithreading" added by Buddha (4/20/93)

#include <mudlib.h>

#define log( x ) log_file( "CHEAT", wrap( "passwd " + ctime(time()) + " "+\
  identify( ({ this_object(), previous_object(), this_player(), x }) ) ) )
#define HACK log(0); notify_fail( "Sorry.  Password security problem.\n" );\
  return 0

inherit DAEMON ;


nomask int cmd_passwd() {
    string name;
    object link;

    if( !this_player() ||
        !userp( this_player() ) ||
        ( this_player() != this_player( 1 ) ) ||
        ( this_player() != previous_object() ) )
      { HACK; }
    name = geteuid( previous_object() );
    link = (object)previous_object()->query_link();
    write("Changing password for "+name+" on " + mud_name() + "\n");
    write("Old password:");
    input_to("oldpass", 1, link);
    return 1;
}

static nomask int oldpass(string pass, object link) {
    string password;

    write ("\n") ;
    if (!pass) {
	write ("The null string is not an acceptable password.\n") ;
	return 0 ;
    }
    password = (string)link->query("password") ;
    if (password != crypt(pass, password)) {
	write ("Password incorrect.\n") ;
	return 0 ;
    }
    write("New password:");
    input_to("newpass", 1, link);
    return 1;
}

static nomask int newpass(string pass, object link) {
    write ("\n") ;
    if (!pass || strlen(pass)<5) {
	write("Your new password must have more than 5 characters.\n");
	return 0;
    }
    write("Again:");
    input_to("npass2", 1, pass, link);
    return 1;
}

static nomask int npass2(string pass, string tmp, object link) {
    write ("\n") ;
    if (pass != tmp) {
	write("The passwords must match.\n");
	return 0;
    }
    if (this_player(1) != this_player()) { HACK; } 
    pass = crypt(pass, 0);
    link->set("password", pass);
    write ("Your password has been changed.\n") ;
    return 1;
}

int
help() {
  write("Command: passwd\nSyntax: passwd\n"+
  "This command lets you change your password.\n"+
  "Do this if you suspect someone may know your old one.\n");
  return 1;
}

/* EOF */
