/*
// reply.c
// Command to send a message to the last person who sent you a tell.
// There was a very old version of this that was wrecked by the move
// to 0.9.0. Prydain and Blackpool played with it. Someone got it
// working but didn't add a header, probably Prydain.
// Mobydick added this header and the help, 11-20-92
// Pallando re-wrote the whole command from new (92-12-12)
// Watcher modified it for use with the new body system (93-03-26)
*/

#include <network.h>
#include <mudlib.h>

inherit DAEMON ;

#define SYNTAX "Syntax: reply <message>\n"

int cmd_reply( string msg ) {
  object user;
  string who, target, mud;

  if( !msg ) { notify_fail( SYNTAX ); return 0; }
 
  who = (string)this_player()-> query( "reply" );
 
  if(!who) {
  notify_fail("No target found for reply.\n");
  return 0; }
 
  who = lower_case( who );
 
  if( sscanf( who, "%s@%s", target, mud ) == 2 )  {
    write( TS_D-> remote_tell( this_player(), target, mud, msg ) );
    return 1;
  }
 
  user = find_player(who);
 
  if(!user) {
  notify_fail(capitalize(who) + " is no longer around.\n");
  return 0; }
 
  if((int)this_player()->query("npc") && !wizardp(user))
  write( wrap( TS_D-> tell_user( this_player()-> query( "name" ),
	0, who, msg)) );
 
  else write( wrap( TS_D->tell_user(this_player()->link_data("name"),
		0, who, msg)) );
 
return 1; }

int help() {
  write( ""+
    SYNTAX +
    "Effect: tells <message> to the last person to send you a tell.\n"+
  "" );
  return 1;
}
