 
/*
//	File	:   /cmds/std/_set.c
//	Creator	:   The people at Portals, no doubt
//	Modified:   Watcher@TMI-2  (01/23/93)
//
//	The standard user's "set" command.
*/

#include <uid.h>
#include <mudlib.h>

inherit DAEMON ;


int cmd_set(string arg)
{
  int i;
  string * vars;
  string value, val, var;
  mixed mix;
  object act_ob;
  
  act_ob = previous_object();
  if (!arg)
    {
      vars = (string *)act_ob->regexp_query_env(".*");
      if (!vars || !sizeof(vars))
	{
	  notify_fail ("No environment variables set.\n");
	  return 0;
	}
      vars = sort_array(vars, "sort_set", this_object());
 
      write ("Environment variables:\n");
      for (i = 0; i < sizeof (vars); i++) 
	{
	  value = (string)act_ob->getenv(vars[i]);
	  if(!stringp(value))	value = "" + value + "";
 
	  printf("%-15s%s\n", vars[i], value);
	}
      return 1;
    }
 
   //	Strip off leading spaces of command request.
 
   while(arg[0] == ' ')  arg = arg[1..sizeof(arg)-1];
 
  if (sscanf(arg,"%s %s",var,val) != 2)
    {
      val = "";
      var = arg;
    }
  if(!(this_player(1) == previous_object() ||
      geteuid(previous_object()) == ROOT_UID) )
    {
      write("Sorry, you are not allowed to set that variable.\n");
      return 1;
    }
  if(act_ob->getenv(var))    write("Variable updated: " + var + "\n");
  else			     write("Variable added: " + var + "\n");
  act_ob->setenv(var,val);
  act_ob->do_new();
  return 1;
}

static int sort_set(string one, string two) {
  return strcmp(one, two);  }

void help ()
{
   write ("Usage: set [variable [value]]\n");
   write ("\nUsed by itself, set lists all environment variables which have been set.\n");
   write ("\nWith just a variable name as an argument, set will set the value of that\nenvironment variable to \"\".\n");
   write ("\nIf given a second argument, a value, a variable is created with that name and\nthat value if it doesn't exist.  If it already exists, the old value is\nreplaced with the new one.\n");
}
