// _shout.c
// Command to have players shout. Shouts reach your room and the adjacent
// rooms only - this is NOT a global shout!
// Written by Mobydick, 11-10-92

#include <mudlib.h>

inherit DAEMON ;
int cmd_shout (string message) {

	mapping rooms ;
	string *roomnames ;
	object ob ;
	int i ;
	string str ;

        if (!message) {
            notify_fail("Shout what?\n");
            return 0;
        }
	write ("You shout: "+message+"\n") ;
	str = this_player()->query("cap_name")+" shouts: "+message+"\n" ;
	say(str) ;
        rooms = environment(this_player());
        if (!rooms) {
            notify_fail("Your shouts go unheard in the void.\n");
            return 0;
        }
	rooms = rooms->query("exits") ;
	roomnames = keys(rooms) ;
	for (i=0;i<sizeof(roomnames);i++) {
		ob = find_object(rooms[roomnames[i]]) ;
		if (ob) tell_room (ob,str) ;
	}
	return 1 ;
}

int help() {
	write ("Usage: shout <message>\n\n"+
"Shout will broadcast <message> to everyone in the room and in all\n"+
"adjacent rooms. It does not reach anyone else in the MUD. If you are\n"+
"trapped by a bug and need help, use \"wizcall\" instead. Do NOT use\n"+
"wizcall for any other reason.\n"+
"See also: say, tell, wizcall\n") ;
	return 1 ;
}
