 
//	File	:  /cmds/std/_tell.c
//	Author	:  Various people (See tell daemon)
//
//	Mudlib tell command.  Also allows intermud-tells.
 
#include <network.h>
#include <mudlib.h>

inherit DAEMON;

#define SYNTAX	"Syntax: tell [who] [message]\n"
/* If you change this, please change it also in /adm/daemons/ts.c */
#define NH " is not on this mud."
 
int cmd_tell(string str) {
    string tell_msg, who, msg, target, mud;
    object ob, act_ob;
    
    act_ob = previous_object();
    
    if( !str || sscanf( str, "%s %s", who, msg ) != 2 ) {
    notify_fail( SYNTAX );
    return 0;  }
    
    notify_fail( capitalize(who) + NH + "\n" );
 
    if(sscanf(who, "%s@%s", target, mud) == 2) {
    write( TS_D->remote_tell(act_ob, target, mud, msg) );
    return 1;  }
 
    who = lower_case( who );
 
    ob = find_player( who );
 
    if(ob && ob->query("npc") && who != (string)ob->query("name") &&
       !wizardp(act_ob))  return 0;
 
    if(!ob) {
 
	if(ob = find_living(who)) {
	tell_object(ob, wrap(act_ob->link_data("cap_name") + " tells you: " +
		    msg) );
	write( wrap("You tell " + capitalize(who) + ": " + msg) );
	ob->set("reply", act_ob->link_data("name"));
	return 1;  }
 
	return 0; }
 
    
    write( wrap(TS_D->tell_user(act_ob->link_data("name"), 0, who, msg)) );
 
return 1; }

int help() {
 
   write( SYNTAX + "\n" +
    "This command allows a user to tell a message to another player or\n" +
    "unique monster, no matter where they are located on the mud. It is\n" +
    "also possible to tell users on another mud a message by using the\n" +
    "@[mud] addition to the user's name (ie: tell watcher@tmi-2 Hi!).\n");
 
return 1; }
 
