/*
// Written By Jubal @ TMI
// Sulam changed the title stuff 1/2/92
// Modified for time zones by DocZ @ TMI (1/20/92)
//
// Modified for players by Truilkan@TMI (02/15/92) -- eventually TMI
// will be used as the base for a real mud and real muds have real players
// that need player-type who commands (those that don't contain for-wizard
// eyes only information.  The original TMI who command has been renamed
// as "people")
// Modified to respect invisibility by Mobydick 10/10/92
// Pallando (93-02-22) Changed [0] to <login> on aesthetic grounds.
// Watcher (93-03-22) Removed User inhabited monsters from the display.
// Watcher (93-04-14) Change the query("invisible") to a visible() check.
*/

#include <writef.h>
#include <mudlib.h>

inherit "/adm/daemons/timezone";
inherit DAEMON ;

string divide;

create()
{
        int i;

	for (divide = "", i = 0 ; i<78 ; i++ )
		divide += "_";
	divide += "\n";
}

void divider()
{
	write(divide);
}

int
cmd_who( string arg )
{
	object *list;
	string line, zone_name;
	int i,time_zone;

	this_player()->block_attack(2) ;
	divider();
 
	list = sort_array(users(), "sort_users", this_object());
	list = filter_array(list, "filter_users", this_object());
 
	if(!sizeof(list)) {
	  write("\tLooks like no one is logged on. Strange beans, huh?\n");
	  divider();
	return 1; }
 
	if( sizeof( list ) > 1 )
		write( "\t\t   There are " + sizeof( list ) +
			" users connected.\n" );
	else // (Buddha claims this message ;-)
		write( "\t\tHow lonely!  You're the only one here.\n" );
 
	zone_name = (string)this_player()->getenv("TZONE");
	time_zone = query_tzone(zone_name);
 
	if (!time_zone) {
	  write( "\t\tMud time is " + ctime( time() ) + "\n" );
                 write("\t\t[Those contained in brackets are editing.]\n");
	} else {
	   write( "\t\t"+zone_name+" time is " + ctime ( time_zone ) + "\n" );
	}
	divider();

	write( writef( "Name", 65, QUIET ) + "  " +
		writef( "Idle", 4, QUIET ) + "\n");

	divider();

	for( i=0 ; i<sizeof(list) ; i++ ) {
		string field;
		mixed val;

		if((int)list[i]->query("npc"))
		field = "(" + capitalize((string)list[i]->link_data("name")) +
			" is inhabiting " + 
			(string)list[i]->query("short") + ")";
		else field = (string) list[i] -> query("short");
 
		if (in_edit(list[i]) || in_input(list[i]))
			field = "[" + field + "]";
		if( ! field ) field = "(null)";
		if( field == "[0]" ) field = "<login>";
		line = writef( field, 65, QUIET|TRUNC_RIGHT ) + "  ";

		val = query_idle( list[i] );
		if( val >= 3600 )
			field = val/3600 + "h";
		else if( val >= 60 )
			field = val/60 + "m";
		else field = "";
		line += writef( field, 4, QUIET|JFY_RIGHT );
		write( line + "\n" );
	}
	divider();
	return 1;
}

int
sort_users(object u1, object u2)
{
    return ( (int)u1->query_level() > (int)u2->query_level() );
}

int filter_users(object who) {
   if((int)who->query("npc") && !wizardp(this_player()))  return 0;
   if(who == this_player())  return 1;		//  You know you're here.
return visible(who, this_player()); }
 
int help() {
	write ("Usage: who\n\n"+
"The who command will give you a list of all user's presently logged\n" +
"onto the MUD, and whether or not they are idle at this time.\n");
 
return 1; }
 
/* EOF */
 
