/*
// This file is a part of the TMI distribution mudlib.
// Please retain this header if you use this code.
// (92-12-07) Written by Douglas Reay (Pallando @ TMI)
// Putting it in home_dir not /tmp from watcher@tmi
// NB if you allow objects in TMP_DIR to be loaded and wish wizards without
// home_dirs to be able to use this command, uncomment the relevant line.
// Changed return to identify efun (92-12-12) Pallando
// Pallando (93-04-15) Put in end desting of object, on IDEA from Robocoder.
// BUG FOUND: some wizards [well, actually only Pallando so far 8-(]
//   get an error on trying:     eval return " \" ";
//   which seems to get written to the temporary file as  " " "
*/
#include <config.h>
#include <mudlib.h>
inherit DAEMON;

#define SYNTAX "Syntax: \"eval <lpc commands>\".\n"

int cmd_eval( string a )
{
  string file, filename;
  mixed err, ret;

  if( !a ) { notify_fail( SYNTAX ); return 0; }
  seteuid( getuid( previous_object() ) );
// The includes in the file arn't necessary (and can be removed if the
// include files on your mud are called something different).  They
// just to make things like   "eval return children( USER )"    possible.
  file = ""+
"#include <daemons.h>\n"+
"#include <commands.h>\n"+
"#include <uid.h>\n"+
"#include <config.h>\n"+
"#include <mudlib.h>\n"+
"inherit OBJECT;\n"+
"create() { seteuid( getuid() ); }\n"+
"doit() { " + a + "; }\n"+
  "";
  filename = user_path( (string)this_player()-> query( "name" ) );
  if( file_size( filename ) != -2 ) 
    { notify_fail( "You must have a valid home directory!\n" ); return 0; }
// filename = TMP_DIR + geteuid( this_player() ) + "_eval.c";
  filename += "CMD_EVAL_TMP_FILE.c";
// long name so won't coincide with file already in your directory by accident
  rm( filename );
  if( ret = find_object( filename ) ) destruct( ret );
  write_file( filename, file );
  if( err = catch( ret = call_other( filename, "doit" ) ) )
    write( "Error = " + err );
  else 
    write( wrap( "Result = " + identify( ret ) ) );
  rm( filename );
  if( ret = find_object( filename ) ) destruct( ret );
// Some muds prefer to change these lines so filename isn't deleted if
// an error occurs.  Also, if you don't have the identify() simul_efun
// the less through dump_variable() simul_efun can be used instead.
  return 1;
}

int help()
{
  write( SYNTAX +
    "Effect: calls a function containing <lpc commands>\n"+
    "Eg, if you type \"eval return function_exists(\"set\",this_player());\"\n"+
    "this creates a temporary file in your home dir containing the line:\n"+
    "    doit() { return function_exists( \"set\", this_player() ); }\n"+
    "and then does call_other on the files's doit()\n"+
    "" );
  return 1;
}
