 
//	File	:  /cmds/xtra/_goto.c
//	Creator	:  Watcher@TMI-2  (4/14/93)
//
//	The standard wizard goto command.
 

#include <move.h>
#include <mudlib.h>

inherit DAEMON ;

static int goto_location(object where);

#define SYNTAX	"Syntax: goto [location | living object]\n"
 
int cmd_goto(string str) {
   object ob;
   int err;

   notify_fail( SYNTAX );

   if(!str || str == "")  return 0;
 
   if( ob = find_living(lower_case(str)) ) 
	return goto_location( environment(ob) );
 
   str = resolv_path("cwd", str);
 
   if(extract(str, strlen(str)-2, strlen(str)-1) != ".c")   str += ".c";
 
   if(!file_exists(str)) {
   write("Goto: No such location or living object found.\n");
   return 1; }

   err = catch( call_other(str, "???") );		// Load up the room
 
   if(!ob = find_object(str)) {
     write("Goto: Could not load " + str + "\n");
     if(err) write("      " + err );
   return 1; }
 
   goto_location( ob );
 
return 1; }

static int goto_location(object where) {
   object old;
   int res;
 
   if(!where | !objectp(where))  return 0;
 
   old = environment( this_player() );
 
   if(old == where) {
     write("You twitch briefly.\n");
     say((string)this_player()->query("cap_name") + " twitchs briefly.\n",
         ({ this_player() }));
   return 1; }
 
   res = this_player()->move_player( where, "" );

   if(res) 
     write("Goto: Could not move to " + identify(where) + ".\n");
 
return 1; }
 
int help() {
 
   write( SYNTAX + "\n" +
     "This command moves a wizard to the desired location, either the\n" +
     "environment of a living object, or the room matching the inputted\n" +
     "filename (ie: goto fred  or  goto /d/Fooland/shop).\n");
 
return 1; }
 
