/*
//	File	:   /cmds/xtra/_path.c
//	Creator	:   The Folks at Portals, of course
//	
//	The command is used to set your command path
//	Updated for protected path checks and path portion
//	removal by Watcher (01/93)
*/

#include <uid.h>
#include <mudlib.h>
 
inherit DAEMON ;

#define PROTECT	({ "/cmds/std", "/cmds/xtra" })
 
int cmd_path(string str) {
   object act_ob;
   string *path, tmp, remove;
   int i, add_path;

   act_ob = previous_object();
   seteuid(ROOT_UID);

   if(!str) {
      str = (string)act_ob->query("PATH");
      if (!str) {
         notify_fail("No path set.\n");
         return 0;
      }
      notify_fail("Current path: "+str+"\n");
      return 0;
   }

   if(sscanf(str,"-add %s", str) || sscanf(str,"%s add",str) ||
      sscanf(str,"%s ADD", str))
		add_path = 1;
 
   else if(sscanf(str,"-rem %s",remove) || sscanf(str,"-remove %s",remove) ||
	  sscanf(str,"%s rem",remove) || sscanf(str,"%s remove",remove) ||
	   sscanf(str,"%s REM",remove) || sscanf(str,"%s REMOVE",remove))
		str = (string)act_ob->query("PATH");

   path = explode(str,":");

   for(i = 0; i < sizeof(path); i++) {
      path[i] = resolv_path("cwd", path[i]);
      if(file_size(path[i]) != -2) {
         notify_fail("Error in path statement. " + 
		path[i] + " is not a directory.\n");
         return 0;
      }
   }
   
   //  If requested, remove specific path portion from user's path
 
   if(remove) {
	remove = resolv_path("cwd", remove);
	path -= ({ remove });  str = implode(path, ":");   }
 
   //  Path aspect protection check
 
   if(!add_path)
   for(i=0; i<sizeof(PROTECT); i++)
   if(member_array(PROTECT[i], path) == -1) {
   write("Path change aborted: You cannot exclude " + PROTECT[i] +
	 " from your path.\n");
   return 1;  }
 
   if(add_path)
      act_ob->add("PATH", ":" + implode(path, ":"));
   else
      act_ob->set("PATH", implode(path, ":"));

   write("Path now set to:\n   "+act_ob->query("PATH")+"\n");
   return 1;
}

int help() {
	write(
	"Usage:\t\tpath\n\t\tpath <new path>\n\t\tpath -add <directory>\n" +
	"\t\tpath -remove <specific path portion>\n\n" +
	"When no argument is given, this will print your current search\n" +
	"path for commands.  When the -add flag is used, it will add the\n" +
	"directory specified to your path.  When the -rem or -remove flag\n" +
	"is used, it will remove that specified segment from your path.\n" +
	"When you wish to set your entire path, the new path is given in\n" +
	"the form dirA:dirB:dirC, for example:\n" +
	"\tpath /cmds/std:/cmds/xtra:/u/b/buddha/bin\n" +
	"will set your path to those three directories.\n" +
	"\nSee also: rehash\n"
	);
	return 1;
}


