 
// File  :  /cmds/xtra/_people.c
//
// Written By Jubal @ TMI
// Sulam changed the title stuff 1/2/92
// Modified for time zones by DocZ @ TMI (1/20/92)
// Modified a tad to include guild info, sulam (april 4, 1992)
// Modified sulam's tad for the new guild info, jubal (Apr12/92)
// Modified to respect invisibility by Mobydick@TMI-2, 10-10-92
// Help added by Mobydick on 11-13-92, from the people.command doc file.
// Inactive label in Idle column added by Watcher on 1-14-93.
// Watcher changed query("invisible") check to use visible(), 4-14-93.

#include <mudlib.h>
#include <writef.h>
#include <daemons.h>
 
inherit DAEMON ;
inherit TIME_D;

string divide;

create()
{
        int i;

	for (divide = "", i = 0 ; i<78 ; i++ )
		divide += "_";
	divide += "\n";
	::create();
}

void divider()
{   write(divide);
}

int cmd_people(string arg) {
    object *list;
    string line, zone_name;
    int i,time_zone;
    mapping domains ;
    object link ;

    divider();
 
    list = sort_array(users(), "sort_users", this_object());
    list = filter_array(list, "filter_users", this_object());
 
    if(!sizeof(list)) {
	write("\tWow, no one is logged on. How'd you manage that? ;)\n");
	divider();
    return 1; }
 
    if (sizeof(list) > 1)
	write("\t\t   There are "+ sizeof(list) +" users connected.\n");
    else
// Buddha thought of this message :-)
	write("\t\tHow lonely!  You're the only one here.\n");

// Time zone code, by Docz
    zone_name = (string)this_player()->getenv("TZONE");
    time_zone = query_tzone(zone_name);
    if (!time_zone)
        write( "\t\tMud time is " + ctime( time() ) + "\n" );
    else
	write( "\t\t"+zone_name+" time is " + ctime ( time_zone ) + "\n" );

    divider();
    printf("%-14s%-12s%-10s%-6s%-22s",
	"Name","Position","Domain", "Idle", "Location\n");
    divider();

    for (i=0; i<sizeof(list); i++)
    {   string field;
	mixed val;

	field = (string) list[i] -> link_data("name");
	if (!field)
	    field = "(null)";
	else
	    field = capitalize(field);
	if(list[i]->query("invisible"))  field = "(" + field + ")";
 
	if ((int)list[i]->query("npc"))  field += " [M]";
 
	if (!list[i]->query("inactive") && 
	    (in_edit(list[i]) || in_input(list[i])))
		field = "*" + field;
	line = sprintf("%-14s", field);
	link = (object) list[i]->query_link() ;
	field = DOMAIN_D->query_domain_level(link) ;
	if (!field) field = "-";
	line += sprintf("%-12s", field);
	field = DOMAIN_D->query_domain(link) ;
	if (!field) field = "-";
	line += sprintf("%-10s", field);
	val = query_idle(list[i]);
	if (list[i]->query("inactive"))   field = "Inact";
	else if ( val <= 0 ) field = "";
	else if( val >= 3600 ) field = val/3600 + "h";
	else if( val >= 60 ) field = val/60 + "m";
	else field = "";
	line += sprintf("%-6s", field);
	val = environment(list[i]);
	if (!val) field = "(null)";
	else field = file_name(val);
	line += sprintf("%-22s", field);
	write( line + "\n" );
    }
    divider();
    return 1;
}

int
sort_users(object u1, object u2)
{
    return ( (int)u1->query_level() > (int)u2->query_level() );
}

//  Can one wizard see the other wizard? 
 
int filter_users(object obj) {  return visible(obj, this_player());  }
 
int help() {
	write (
"Usage: people\n\n"+
"The people command lists the following facts about logged on users:\n"+
"guild membership and position, idle time, and current location.\n"+
"People marked with an asterisk (*) are using the editor.\n"+
"It also prints the time of day and the number of people logged on. If\n"+
"a wizard sets his invisibility to \"wizard\", then he will not appear on\n"+
"the output of the people command unless the command is invoked by an\n"+
"administrator.\n\n"+
"See also: who, finger.\n") ;
	return 1;
}
/* EOF */
