 
//   File  :  /include/config.h
//
//   This include file controls the major macro defines for 
//   the mudlib's base systems.
 
#ifndef __CONFIG_H
#define __CONFIG_H
 
//  The base distribution mudlib name.  

#define MUDLIB_VERSION	"TMI-2 1.0.1"
 

//  Directory path defines
 
#define PDATA_DIR	"/data/std/connection"		
#define DATA_DIR	"/data"
#define CONFIG_DIR	"/adm/etc/"
#define SECURE_DIR	"/adm/"
#define HOME_DIRS	"/u/"
#define LOG_DIR		"/log/"
#define NEWS_DIR 	"/adm/news/"
#define TMP_DIR		"/tmp/"
#define HELP_DIR	"/doc/help/"
#define WIZH_DIR	"/doc/wizhelp/"
#define PROPH_DIR	"/doc/properties/"
#define ARCHIVE_DIR	"/data/attic/"
#define SIMUL_EFUN_DIR	"/adm/simul_efun/"
 
//  System objects
 
#define USER_OB		"/std/user"
#define CONNECTION	"/std/connection"
#define GROUP_OB	"/adm/obj/master/groups"
#define ACCESS_OB	"/adm/obj/master/access"
#define MASTER_OB	master()
#define SIMUL_EFUN_OB	"/adm/obj/simul_efun"
 
//  User command locations
 
#define WIZ_CMDS 	"/cmds/xtra"
#define WIZF_CMDS 	"/cmds/file"
#define USER_CMDS 	"/cmds/std"
#define ADM_CMDS 	"/cmds/adm"
#define CHAN_CMDS	"/cmds/channels"
#define REF_CMDS 	"/cmds/refs"
 
//  Important global mudlib informatioin
 
#define MUD_ADDRESSES 	"/adm/etc/mud_addresses"
#define MUD_SERVICES 	"/adm/etc/mud_services"
#define THIS_MUD 	lower_case(implode(explode(mud_name(), " "), "."))
#define ADMIN_EMAIL	"your,userid@your.host.goes.here"
 
//  The AUTO_WIZHOOD define causes all those to login as new users to be
//  granted automatic wizship, and given the PATH in the define.
 
#define AUTO_WIZHOOD	USER_CMDS+":"+WIZ_CMDS+":"+WIZF_CMDS+":"+ \
			REF_CMDS+":"+CHAN_CMDS
 
 
//  Mudlib definable locations
 
#define START		"/d/Fooland/hall"
#define VOID		"/d/std/void"

#endif /* __CONFIG_H */
 
