//  cod:  Call_Out Debugger
//  by:   Archimedes@TMI-2

#include <mudlib.h>

inherit OBJECT;

void clean_up() { destruct(this_object()); }

void create()
{
	set("id", ({"cod", "fish"}));
	set("short", "a cod fish");
	set("bulk", 5);
	set("long", "This is an electronic fish designed to debug call_outs.\n");
	set("capacity", 0);
}

void init()
{
	add_action("list_calls", "calls");
	add_action("help", "help");
}

int list_calls()
{
	int i, s;
	mixed *info;
	string ob;

	info = call_out_info();
	s = sizeof(info);
	i = s;

	printf("%-30s%-15s%-10s%-15s\n", "Object", "Function", "Delay", "Arguments");
	write("------------------------------------------------------------------------------");

	while(i--) {

	  if(catch(objectp(info[i][0])))
	     ob = "(null)";
	   else
	     ob=file_name(info[i][0]);

          catch(printf("\n%-30s%-15s%5d", ob, info[i][1], info[i][2]));
	  write("      ");
	  catch(write(info[i][3]));
	}

	write("\n------------------------------------------------------------------------------\n");
	printf("\t\t\t%s: %d\n", "Total call_outs", s);

	return 1;
}

int help(string arg)
{
	if(!(arg == "cod" || arg == "fish")) 
		return 0;
	write("\
This device provides information about all pending call_outs.  To view\n\
the information, type calls.  The cod, 'Call_Out Debugger', was written\n\
by Archimedes@TMI-2.  Mail him bug reports.\n");
	return 1;
}
