/*
 * environment variables
 */

private mapping env_var;

mixed query_env (string env);

/*
 * add_property adds a property to a list or modifies an existing prop
 * If the property is changed 1 is returned... Otherwise 0 is returned.
 * the function property_change() is called in the object for each call to
 * add_property. It is passed the property change. And the old value it had
 * if it is recently added it will be passed "ADDED" as the old value
 */

int setenv (string env, mixed value)
{
  if(!env_var)
    env_var = ([]);
  
  if(env_var[env])
    {
      env_var[env] = value;
      return 1;
    }
  
  env_var += ([ env : value]);
  return 1;
}

int set_env (string env, mixed value) {
  return setenv(env, value);
}

mixed getenv(string env)
{
  if(!env_var) 
    {
      env_var = ([]);
      return 0;
    }
  return env_var[env];
}

mixed query_env(string env) {
  return getenv(env);
}

int remove_env (string env)
{
  if(env_var && env_var[env])
    {
      map_delete(env_var, env);
      return 1;
    }
  return 0;
}

string * regexp_query_env (string pattern)
{
   string *vars, *env;

   vars = keys(env_var);
   vars -= ({ 0 }); /* may as well skip all the "deleted" ones for now */
   env = regexp (vars, pattern);
   if (!env) 
     env = ({});
   return env;
}
