// This file contains the stuff for those funky movement messages you
// see when you move around... actually other people see them and not you.
// Be kind and admit that while you don't know who wrote this, that it did
// come from TMI.
// While you're at it, admit to a sneaking suspicion that Sulam may have
// been the author, although the concept probably goes back further than
// that.


string validate(string str, string *vars) {
    string foo;
    int x;

    if( !str ) return "";
    for (x = 0; x < sizeof( vars ); x++)
	if( !( sscanf(str, "%s"+vars[x]+"%s", foo) ) )
	    return "";
    return str;
}

string query_min() {
    string str;

    str = (string)this_object()->getenv("MIN");
    str = validate( str, ({ "$N" }) );
    if( str == "" ) str = "$N enters.";
    str = substr( str, "$N", (string)this_object()->query("cap_name") );
    return str;
}

string query_mout(string dir) {
    string str;

    str = (string)this_object()->getenv("MOUT");
    str = validate( str, ({ "$N", "$D" }) );
    if( str == "" ) str = "$N leaves $D.";
    str = substr( str, "$N", (string)this_object()->query("cap_name") );
    if (dir == "" || dir == 0) return str;
    str = substr( str, "$D", dir );
    return str;
}

string query_mmin() {
    string str;

    str = (string)this_object()->getenv("MMIN");
    str = validate( str, ({ "$N" }) );
    if( str == "" ) str = "$N appears from the shadows.";
    str = substr( str, "$N", (string)this_object()->query("cap_name") );
    return str;
}

string query_mmout() {
    string str;

    str = (string)this_object()->getenv("MMOUT");
    str = validate( str, ({ "$N" }) );
    if( str == "" ) str = "$N fades into the shadows.";
    str = substr( str, "$N", (string)this_object()->query("cap_name") );
    return str;
}

string query_mhome() {
    string str;

    str = (string)this_object()->getenv("MHOME");
    str = validate( str, ({ "$N" }) );
    if( str == "" ) str = "$N heads home.";
    str = substr( str, "$N", (string)this_object()->query("cap_name") );
    return str;
}

string query_mdest(object obj) {
    string str;

    str = (string)this_object()->getenv("MDEST");
    str = validate( str, ({ "$N", "$O" }) );
    if( str == "" ) str = "$N disintegrates $O";
    str = substr( str, "$N", (string)this_object()->query("cap_name") );
    if (obj == 0) return str;
    if( obj->query("short") )
        str = substr( str, "$O", (string)obj->query("short") );
    else
        str = substr( str, "$O", "something" );
    return str;
}

string query_mclone(object obj) {
    string str;

	str = (string)this_object()->getenv("MCLONE");
	str = validate( str, ({ "$N", "$O" }) );
	if( str == "" ) str = "$N gets creative and makes $O.";
	str = substr( str, "$N", (string)this_player()->query("cap_name") );
       if (obj == 0) return str;
	if( obj->query("short") )
		str = substr( str, "$O", (string)obj->query("short") );
	else str = substr( str, "$O", "something" );
	return str;
}

string query_mvis() {
    string str;

    str = (string)this_object()->getenv("MVIS");
    str = validate( str, ({ "$N" }) );
    if( str == "" ) str = "$N appears out of the corner of your eye.";
    str = substr( str, "$N", (string)this_object()->query("cap_name") );
    return str;
}

string query_minvis() {
    string str;

    str = (string)this_object()->getenv("MINVIS");
    str = validate( str, ({ "$N" }) );
    if( str == "" ) str = "$N seems to disappear.";
    str = substr( str, "$N", (string)this_object()->query("cap_name") );
    return str;
}
